Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/QuickTime.pm	(revision 34921)
@@ -2485,27 +9236,47 @@
                     }
                     my %dirInfo = (
-                        DataPt   => \$val,
-                        DataLen  => $size,
-                        DirStart => $start,
-                        DirLen   => $size - $start,
-                        DirName  => $$subdir{DirName} || $$tagInfo{Name},
-                        HasData  => $$subdir{HasData},
-                        Multi    => $$subdir{Multi},
-                        DataPos  => $dPos,
-                        # Base needed for IsOffset tags in binary data
-                        Base     => $base,
+                        DataPt     => \$val,
+                        DataLen    => $size,
+                        DirStart   => $start,
+                        DirLen     => $size - $start,
+                        DirName    => $$subdir{DirName} || $$tagInfo{Name},
+                        DirID      => $tag,
+                        HasData    => $$subdir{HasData},
+                        Multi      => $$subdir{Multi},
+                        IgnoreProp => $$subdir{IgnoreProp}, # (XML hack)
+                        DataPos    => $dPos,
+                        Base       => $base, # (needed for IsOffset tags in binary data)
                     );
+                    $dirInfo{BlockInfo} = $tagInfo if $$tagInfo{BlockExtract};
                     if ($$subdir{ByteOrder} and $$subdir{ByteOrder} =~ /^Little/) {
                         SetByteOrder('II');
                     }
-                    my $oldGroup1 = $exifTool->{SET_GROUP1};
-                    if ($$tagInfo{Name} eq 'Track') {
+                    my $oldGroup1 = $$et{SET_GROUP1};
+                    if ($$tagInfo{SubDirectory} and $$tagInfo{SubDirectory}{TagTable} and
+                        $$tagInfo{SubDirectory}{TagTable} eq 'Image::ExifTool::QuickTime::Track')
+                    {
                         $track or $track = 0;
-                        $exifTool->{SET_GROUP1} = 'Track' . (++$track);
+                        $$et{SET_GROUP1} = 'Track' . (++$track);
                     }
                     my $subTable = GetTagTable($$subdir{TagTable});
                     my $proc = $$subdir{ProcessProc};
-                    $exifTool->ProcessDirectory(\%dirInfo, $subTable, $proc) if $size > $start;
-                    $exifTool->{SET_GROUP1} = $oldGroup1;
+                    # make ProcessMOV() the default processing procedure for subdirectories
+                    $proc = \&ProcessMOV unless $proc or $$subTable{PROCESS_PROC};
+                    if ($size > $start) {
+                        # delay processing of ipco box until after all other boxes
+                        if ($tag eq 'ipco' and not $$et{IsItemProperty}) {
+                            $$et{ItemPropertyContainer} = [ \%dirInfo, $subTable, $proc ];
+                            $et->VPrint(0,"$$et{INDENT}\[Process ipco box later]");
+                        } else {
+                            $et->ProcessDirectory(\%dirInfo, $subTable, $proc);
+                        }
+                    }
+                    if ($tag eq 'stbl') {
+                        # process sample data when exiting SampleTable box if extracting embedded
+                        ProcessSamples($et) if $ee;
+                    } elsif ($tag eq 'minf') {
+                        $$et{HandlerType} = ''; # reset handler type at end of media info box
+                    }
+                    $$et{SET_GROUP1} = $oldGroup1;
                     SetByteOrder('MM');
                 } elsif ($hasData) {
@@ -2517,5 +9288,5 @@
                         my ($len, $type, $flags, $ctry, $lang) = unpack("x${pos}Na4Nnn", $val);
                         last if $pos + $len > $size;
-                        my $value;
+                        my ($value, $langInfo, $oldDir);
                         my $format = $$tagInfo{Format};
                         if ($type eq 'data' and $len >= 16) {
@@ -2530,23 +9301,9 @@
                             if ($stringEncoding{$flags}) {
                                 # handle all string formats
-                                $value = $exifTool->Decode($value, $stringEncoding{$flags});
+                                $value = $et->Decode($value, $stringEncoding{$flags});
+                                # (shouldn't be null terminated, but some software writes it anyway)
+                                $value =~ s/\0$// unless $$tagInfo{Binary};
                             } else {
-                                if (not $format) {
-                                    if ($flags == 0x15 or $flags == 0x16) {
-                                        $format = { 1=>'int8', 2=>'int16', 4=>'int32' }->{$len};
-                                        $format .= $flags == 0x15 ? 's' : 'u' if $format;
-                                    } elsif ($flags == 0x17) {
-                                        $format = 'float';
-                                    } elsif ($flags == 0x18) {
-                                        $format = 'double';
-                                    } elsif ($flags == 0x00) {
-                                        # read 1 and 2-byte binary as integers
-                                        if ($len == 1) {
-                                            $format = 'int8u',
-                                        } elsif ($len == 2) {
-                                            $format = 'int16u',
-                                        }
-                                    }
-                                }
+                                $format = QuickTimeFormat($flags, $len) unless $format;
                                 if ($format) {
                                     $value = ReadValue(\$value, 0, $format, $$tagInfo{Count}, $len);
@@ -2558,24 +9315,18 @@
                             }
                         }
-                        my $langInfo;
                         if ($ctry or $lang) {
-                            # ignore country ('ctry') and language lists ('lang') for now
-                            undef $ctry if $ctry and $ctry <= 255;
-                            undef $lang if $lang and $lang <= 255;
-                            $lang = UnpackLang($lang);
-                            # add country code if specified
-                            if ($ctry) {
-                                $ctry = unpack('a2',pack('n',$ctry)); # unpack as ISO 3166-1
-                                # treat 'ZZ' like a default country (see ref 12)
-                                undef $ctry if $ctry eq 'ZZ';
-                                if ($ctry and $ctry =~ /^[A-Z]{2}$/) {
-                                    $lang or $lang = 'und';
-                                    $lang .= "-$ctry";
+                            my $langCode = GetLangCode($lang, $ctry);
+                            if ($langCode) {
+                                # get tagInfo for other language
+                                $langInfo = GetLangInfoQT($et, $tagInfo, $langCode);
+                                # save other language tag ID's so we can delete later if necessary
+                                if ($langInfo) {
+                                    $$tagInfo{OtherLang} or $$tagInfo{OtherLang} = [ ];
+                                    push @{$$tagInfo{OtherLang}}, $$langInfo{TagID};
                                 }
                             }
-                            $langInfo = Image::ExifTool::GetLangInfo($tagInfo, $lang) if $lang;
                         }
                         $langInfo or $langInfo = $tagInfo;
-                        $exifTool->VerboseInfo($tag, $langInfo,
+                        $et->VerboseInfo($tag, $langInfo,
                             Value   => ref $value ? $$value : $value,
                             DataPt  => \$val,
@@ -2584,23 +9335,44 @@
                             Size    => $len,
                             Format  => $format,
-                            Extra   => sprintf(", Type='$type', Flags=0x%x",$flags)
+                            Index   => $index,
+                            Extra   => sprintf(", Type='${type}', Flags=0x%x, Lang=0x%.4x",$flags,$lang),
                         ) if $verbose;
-                        $exifTool->FoundTag($langInfo, $value) if defined $value;
+                        # use "Keys" in path instead of ItemList if this was defined by a Keys tag
+                        my $isKey = $$tagInfo{Groups} && $$tagInfo{Groups}{1} && $$tagInfo{Groups}{1} eq 'Keys';
+                        if ($isKey) {
+                            $oldDir = $$et{PATH}[-1];
+                            $$et{PATH}[-1] = 'Keys';
+                        }
+                        $et->FoundTag($langInfo, $value) if defined $value;
+                        $$et{PATH}[-1] = $oldDir if $isKey;
                         $pos += $len;
                     }
-                } elsif ($tag =~ /^\xa9/) {
+                } elsif ($tag =~ /^\xa9/ or $$tagInfo{IText}) {
                     # parse international text to extract all languages
                     my $pos = 0;
+                    if ($$tagInfo{Format}) {
+                        $et->FoundTag($tagInfo, ReadValue(\$val, 0, $$tagInfo{Format}, undef, length($val)));
+                        $pos = $size;
+                    }
                     for (;;) {
-                        last if $pos + 4 > $size;
-                        my ($len, $lang) = unpack("x${pos}nn", $val);
-                        $pos += 4;
-                        # according to the QuickTime spec (ref 12), $len should include
-                        # 4 bytes for length and type words, but nobody (including
-                        # Apple, Pentax and Kodak) seems to add these in, so try
-                        # to allow for either
-                        if ($pos + $len > $size) {
-                            $len -= 4;
-                            last if $pos + $len > $size or $len < 0;
+                        my ($len, $lang);
+                        if ($$tagInfo{IText} and $$tagInfo{IText} == 6) {
+                            last if $pos + 6 > $size;
+                            $pos += 4;
+                            $lang = unpack("x${pos}n", $val);
+                            $pos += 2;
+                            $len = $size - $pos;
+                        } else {
+                            last if $pos + 4 > $size;
+                            ($len, $lang) = unpack("x${pos}nn", $val);
+                            $pos += 4;
+                            # according to the QuickTime spec (ref 12), $len should include
+                            # 4 bytes for length and type words, but nobody (including
+                            # Apple, Pentax and Kodak) seems to add these in, so try
+                            # to allow for either
+                            if ($pos + $len > $size) {
+                                $len -= 4;
+                                last if $pos + $len > $size or $len < 0;
+                            }
                         }
                         # ignore any empty entries (or null padding) after the first
@@ -2608,15 +9380,21 @@
                         my $str = substr($val, $pos, $len);
                         my $langInfo;
-                        if ($lang < 0x400) {
+                        if (($lang < 0x400 or $lang == 0x7fff) and $str !~ /^\xfe\xff/) {
                             # this is a Macintosh language code
                             # a language code of 0 is Macintosh english, so treat as default
-                            if ($lang) { 
-                                # use Font.pm to look up language string
-                                require Image::ExifTool::Font;
-                                $lang = $Image::ExifTool::Font::ttLang{Macintosh}{$lang};
+                            if ($lang) {
+                                if ($lang == 0x7fff) {
+                                    # technically, ISO 639-2 doesn't have a 2-character
+                                    # equivalent for 'und', but use 'un' anyway
+                                    $lang = 'un';
+                                } else {
+                                    # use Font.pm to look up language string
+                                    require Image::ExifTool::Font;
+                                    $lang = $Image::ExifTool::Font::ttLang{Macintosh}{$lang};
+                                }
                             }
-                            # the spec says only "Macintosh text encoding", so
-                            # I can only assume that it is the most common one
-                            $str = $exifTool->Decode($str, 'MacRoman');
+                            # the spec says only "Macintosh text encoding", but
+                            # allow this to be configured by the user
+                            $str = $et->Decode($str, $charsetQuickTime);
                         } else {
                             # convert language code to ASCII (ignore read-only bit)
@@ -2624,24 +9402,82 @@
                             # may be either UTF-8 or UTF-16BE
                             my $enc = $str=~s/^\xfe\xff// ? 'UTF16' : 'UTF8';
-                            $str = $exifTool->Decode($str, $enc);
+                            $str = $et->Decode($str, $enc);
                         }
-                        $langInfo = Image::ExifTool::GetLangInfo($tagInfo, $lang) if $lang;
-                        $exifTool->FoundTag($langInfo || $tagInfo, $str);
+                        $str =~ s/\0+$//;   # remove any trailing nulls (eg. 3gp tags)
+                        $langInfo = GetLangInfoQT($et, $tagInfo, $lang) if $lang;
+                        $et->FoundTag($langInfo || $tagInfo, $str);
                         $pos += $len;
                     }
                 } else {
-                    if ($$tagInfo{Format}) {
-                        $val = ReadValue(\$val, 0, $$tagInfo{Format}, $$tagInfo{Count}, length($val));
+                    my $format = $$tagInfo{Format};
+                    if ($format) {
+                        $val = ReadValue(\$val, 0, $format, $$tagInfo{Count}, length($val));
                     }
-                    $exifTool->FoundTag($tagInfo, $val);
+                    my $oldBase;
+                    if ($$tagInfo{SetBase}) {
+                        $oldBase = $$et{BASE};
+                        $$et{BASE} = $dataPos;
+                    }
+                    my $key = $et->FoundTag($tagInfo, $val);
+                    $$et{BASE} = $oldBase if defined $oldBase;
+                    # decode if necessary (NOTE: must be done after RawConv)
+                    if (defined $key and (not $format or $format =~ /^string/) and
+                        not $$tagInfo{Unknown} and not $$tagInfo{ValueConv} and
+                        not $$tagInfo{Binary} and defined $$et{VALUE}{$key} and not ref $val)
+                    {
+                        my $vp = \$$et{VALUE}{$key};
+                        if (not ref $$vp and length($$vp) <= 65536 and $$vp =~ /[\x80-\xff]/) {
+                            # the encoding of this is not specified, so use CharsetQuickTime
+                            # unless the string is valid UTF-8
+                            require Image::ExifTool::XMP;
+                            my $enc = Image::ExifTool::XMP::IsUTF8($vp) > 0 ? 'UTF8' : $charsetQuickTime;
+                            $$vp = $et->Decode($$vp, $enc);
+                        }
+                    }
                 }
             }
         } else {
-            $raf->Seek($size, 1) or $exifTool->Warn("Truncated '$tag' data"), last;
+            $et->VerboseInfo($tag, $tagInfo,
+                Size  => $size,
+                Extra => sprintf(' at offset 0x%.4x', $raf->Tell()),
+            ) if $verbose;
+            if ($size and (not $raf->Seek($size-1, 1) or $raf->Read($buff, 1) != 1)) {
+                my $t = PrintableTagID($tag,2);
+                $et->Warn("Truncated '${t}' data");
+                last;
+            }
         }
+        $dataPos += $size + 8;  # point to start of next atom data
+        last if $dirEnd and $dataPos >= $dirEnd; # (note: ignores last value if 0 bytes)
         $raf->Read($buff, 8) == 8 or last;
-        $dataPos += $size + 8;
         ($size, $tag) = unpack('Na4', $buff);
+        ++$index if defined $index;
     }
+    # fill in missing defaults for alternate language tags
+    # (the first language is taken as the default)
+    if ($doDefaultLang and $$et{QTLang}) {
+QTLang: foreach $tag (@{$$et{QTLang}}) {
+            next unless defined $$et{VALUE}{$tag};
+            my $langInfo = $$et{TAG_INFO}{$tag} or next;
+            my $tagInfo = $$langInfo{SrcTagInfo} or next;
+            my $infoHash = $$et{TAG_INFO};
+            my $name = $$tagInfo{Name};
+            # loop through all instances of this tag name and generate the default-language
+            # version only if we don't already have a QuickTime tag with this name
+            my ($i, $key);
+            for ($i=0, $key=$name; $$infoHash{$key}; ++$i, $key="$name ($i)") {
+                next QTLang if $et->GetGroup($key, 0) eq 'QuickTime';
+            }
+            $et->FoundTag($tagInfo, $$et{VALUE}{$tag});
+        }
+        delete $$et{QTLang};
+    }
+    # process item information now that we are done processing its 'meta' container
+    HandleItemInfo($et) if $topLevel or $dirID eq 'meta';
+
+    ScanMediaData($et) if $ee and $topLevel;  # brute force scan for metadata embedded in media data
+
+    # restore any changed options
+    $et->Options($_ => $saveOptions{$_}) foreach keys %saveOptions;
     return 1;
 }
@@ -2653,7 +9489,7 @@
 sub ProcessQTIF($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $table = GetTagTable('Image::ExifTool::QuickTime::ImageFile');
-    return ProcessMOV($exifTool, $dirInfo, $table);
+    return ProcessMOV($et, $dirInfo, $table);
 }
 
@@ -2673,9 +9509,9 @@
 
 This module contains routines required by Image::ExifTool to extract
-information from QuickTime and MP4 video, and M4A audio files.
+information from QuickTime and MP4 video, M4A audio, and HEIC image files.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
